#include "msg.h"
#include "tbx_fifo.h"

typedef enum {
  REQUEST_CHANNEL = 0,
  GENERAL_CHANNEL,
  MAX_CHANNEL
} channel_t;

/*-----[ Task creation ]---------------------------*/
m_task_t work_task_create(void);
void work_task_destroy(m_task_t * task);

typedef struct s_request_data {
  m_host_t who_am_i;
  float computing_power;
  float bandwidth;
} *request_data_t;

m_task_t request_task_create(m_host_t who_am_i);
void request_task_destroy(m_task_t * task);

extern float task_computation_amount;
extern float task_communication_amount;
extern float request_computation_amount;
extern float request_communication_amount;
extern float global_time;

void sched_master(int argc, char *argv[]);
void sched_wiser_master(int argc, char *argv[]);
void sched_slave(int argc, char *argv[]);
void sched_wiser_slave(int argc, char *argv[]);
